/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
"use strict";function getApplicationPath(){return process.env.VSCODE_DEV?appRoot:"darwin"===process.platform?path.dirname(path.dirname(path.dirname(appRoot))):path.dirname(path.dirname(appRoot))}function getPortableDataPath(){if(process.env.VSCODE_PORTABLE)return process.env.VSCODE_PORTABLE;if("win32"===process.platform||"linux"===process.platform)return path.join(getApplicationPath(),"data");{const e=product.portable||`${product.applicationName}-portable-data`;return path.join(path.dirname(getApplicationPath()),e)}}function getUserDataPath(){return isPortable?path.join(portableDataPath,"user-data"):path.resolve(args["user-data-dir"]||paths.getDefaultUserDataPath(process.platform))}function stripComments(e){return e.replace(/("(?:[^\\\"]*(?:\\.)?)*")|('(?:[^\\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g,function(e,r,a,t,n){if(t)return"";if(n){let e=n.length;return e>2&&"\n"===n[e-1]?"\r"===n[e-2]?"\r\n":"\n":""}return e})}function mkdirp(e){return mkdir(e).then(null,r=>{
if(r&&"ENOENT"===r.code){const r=path.dirname(e);if(r!==e)return mkdirp(r).then(()=>mkdir(e))}throw r})}function rimraf(e){return lstat(e).then(r=>r.isDirectory()&&!r.isSymbolicLink()?readdir(e).then(r=>Promise.all(r.map(r=>rimraf(path.join(e,r))))).then(()=>rmdir(e)):unlink(e),e=>{if("ENOENT"!==e.code)throw e})}function resolveJSFlags(...e){return args["js-flags"]&&e.push(args["js-flags"]),args["max-memory"]&&!/max_old_space_size=(\d+)/g.exec(args["js-flags"])&&e.push(`--max_old_space_size=${args["max-memory"]}`),e.length>0?e.join(" "):null}function getUserDefinedLocale(){let e=args.locale;if(e)return Promise.resolve(e.toLowerCase());let r=path.join(userDataPath,"User","locale.json");return exists(r).then(e=>e?readFile(r).then(e=>{e=stripComments(e);try{let r=JSON.parse(e).locale;return r&&"string"==typeof r?r.toLowerCase():void 0}catch(e){return}}):void 0)}function getLanguagePackConfigurations(){let e=path.join(userDataPath,"languagepacks.json");try{return require(e)}catch(e){}}
function resolveLanguagePackLocale(e,r){try{for(;r;){if(e[r])return r;{let e=r.lastIndexOf("-");if(!(e>0))return;r=r.substring(0,e)}}}catch(e){console.error("Resolving language pack configuration failed.",e)}}function getNLSConfiguration(e){if("pseudo"===e)return Promise.resolve({locale:e,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:e,availableLanguages:{}});if(e&&("en"==e||e.startsWith("en-")))return Promise.resolve({locale:e,availableLanguages:{}});let r=e;perf.mark("nlsGeneration:start");let a=function(e){return perf.mark("nlsGeneration:end"),Promise.resolve({locale:e,availableLanguages:{}})};try{let t=product.commit;if(!t)return a(r);let n=getLanguagePackConfigurations();if(!n)return a(r);if(!(e=resolveLanguagePackLocale(n,e)))return a(r);let o,s=n[e];return s&&"string"==typeof s.hash&&s.translations&&"string"==typeof(o=s.translations.vscode)?exists(o).then(n=>{if(!n)return a(r)
;let i=s.hash+"."+e,l=path.join(userDataPath,"clp",i),p=path.join(l,t),c=path.join(l,"tcf.json"),u=path.join(l,"corrupted.info"),f={locale:r,availableLanguages:{"*":e},_languagePackId:i,_translationsConfigFile:c,_cacheRoot:l,_resolvedLanguagePackCoreLocation:p,_corruptedFile:u};return exists(u).then(r=>{let t;return(t=r?rimraf(l):Promise.resolve(void 0)).then(()=>exists(p).then(r=>r?(touch(p).catch(()=>{}),perf.mark("nlsGeneration:end"),f):mkdirp(p).then(()=>Promise.all([readFile(path.join(__dirname,"nls.metadata.json")),readFile(o)])).then(e=>{let r=JSON.parse(e[0]),a=JSON.parse(e[1]).contents,t=Object.keys(r.bundles),n=[];for(let e of t){let t=r.bundles[e],o=Object.create(null);for(let e of t){let t,n=r.keys[e],s=r.messages[e],i=a[e];if(i){t=[];for(let e=0;e<n.length;e++){let r=n[e],a=i["string"==typeof r?r:r.key];void 0===a&&(a=s[e]),t.push(a)}}else t=s;o[e]=t}n.push(writeFile(path.join(p,e.replace(/\//g,"!")+".nls.json"),JSON.stringify(o)))}return n.push(writeFile(c,JSON.stringify(s.translations))),
Promise.all(n)}).then(()=>(perf.mark("nlsGeneration:end"),f)).catch(r=>(console.error("Generating translation files failed.",r),a(e)))))})}):a(r)}catch(r){return console.error("Generating translation files failed.",r),a(e)}}const perf=require("./vs/base/common/performance");perf.mark("main:started"),global.perfStartTime=Date.now(),Error.stackTraceLimit=100;const fs=require("fs"),path=require("path"),product=require("../product.json"),appRoot=path.dirname(__dirname),portableDataPath=getPortableDataPath(),isPortable=fs.existsSync(portableDataPath),portableTempPath=path.join(portableDataPath,"tmp"),isTempPortable=isPortable&&fs.existsSync(portableTempPath);isPortable?process.env.VSCODE_PORTABLE=portableDataPath:delete process.env.VSCODE_PORTABLE,isTempPortable&&(process.env["win32"===process.platform?"TEMP":"TMPDIR"]=portableTempPath),function(){const e=require("path"),r=require("module"),a=e.join(__dirname,"../node_modules"),t=a+".asar",n=r._resolveLookupPaths;r._resolveLookupPaths=function(e,r,o){
const s=n(e,r,o),i=o?s:s[1];for(let e=0,r=i.length;e<r;e++)if(i[e]===a){i.splice(e,0,t);break}return s}}();const app=require("electron").app;app.commandLine.appendSwitch("disable-mojo-local-storage"),app.commandLine.appendSwitch("force-color-profile","srgb");const minimist=require("minimist"),paths=require("./paths"),args=minimist(process.argv,{string:["user-data-dir","locale","js-flags","max-memory"]}),userDataPath=getUserDataPath();app.setPath("userData",userDataPath);const mkdir=e=>new Promise((r,a)=>fs.mkdir(e,t=>t&&"EEXIST"!==t.code?a(t):r(e))),exists=e=>new Promise(r=>fs.exists(e,r)),readFile=e=>new Promise((r,a)=>fs.readFile(e,"utf8",(e,t)=>e?a(e):r(t))),writeFile=(e,r)=>new Promise((a,t)=>fs.writeFile(e,r,"utf8",e=>e?t(e):a())),touch=e=>new Promise((r,a)=>{const t=new Date;fs.utimes(e,t,t,e=>e?a(e):r())
}),lstat=e=>new Promise((r,a)=>fs.lstat(e,(e,t)=>e?a(e):r(t))),readdir=e=>new Promise((r,a)=>fs.readdir(e,(e,t)=>e?a(e):r(t))),rmdir=e=>new Promise((r,a)=>fs.rmdir(e,e=>e?a(e):r(void 0))),unlink=e=>new Promise((r,a)=>fs.unlink(e,e=>e?a(e):r(void 0))),nodeCachedDataDir=new class{constructor(){this.value=this._compute()}jsFlags(){return this.value?"--nolazy":void 0}ensureExists(){return mkdirp(this.value).then(()=>this.value,()=>{})}_compute(){if(process.argv.indexOf("--no-cached-data")>0)return;if(process.env.VSCODE_DEV)return;let e=product.commit;if(e)return path.join(userDataPath,"CachedData",e)}};try{"win32"===process.platform?(process.env.VSCODE_CWD=process.cwd(),process.chdir(path.dirname(app.getPath("exe")))):process.env.VSCODE_CWD&&process.chdir(process.env.VSCODE_CWD)}catch(e){console.error(e)}global.macOpenFiles=[],app.on("open-file",function(e,r){global.macOpenFiles.push(r)});let openUrls=[],onOpenUrl=function(e,r){e.preventDefault(),openUrls.push(r)};app.on("will-finish-launching",function(){
app.on("open-url",onOpenUrl)}),global.getOpenUrls=function(){return app.removeListener("open-url",onOpenUrl),openUrls};let nlsConfiguration=void 0,userDefinedLocale=getUserDefinedLocale();userDefinedLocale.then(e=>{e&&!nlsConfiguration&&(nlsConfiguration=getNLSConfiguration(e))});let jsFlags=resolveJSFlags(nodeCachedDataDir.jsFlags());jsFlags&&app.commandLine.appendSwitch("--js-flags",jsFlags),app.once("ready",function(){perf.mark("main:appReady"),Promise.all([nodeCachedDataDir.ensureExists(),userDefinedLocale]).then(([e,r])=>{r&&!nlsConfiguration&&(nlsConfiguration=getNLSConfiguration(r)),nlsConfiguration||(nlsConfiguration=Promise.resolve(void 0)),nlsConfiguration.then(r=>{let a=r=>{process.env.VSCODE_NLS_CONFIG=JSON.stringify(r),e&&(process.env["VSCODE_NODE_CACHED_DATA_DIR_"+process.pid]=e),require("./bootstrap-amd").bootstrap("vs/code/electron-main/main")};if(r)a(r);else{let e=app.getLocale();e?getNLSConfiguration(e=e.toLowerCase()).then(r=>{r||(r={locale:e,availableLanguages:{}}),a(r)}):a({locale:"en",
availableLanguages:{}})}})},console.error)});
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4e9361845dc28659923a300945f84731393e210d/core/main.js.map
